#!/usr/bin/env ruby

require 'mapping'
require 'virtual_machine_si'
require 'one_si'
require 'libvirt_si'

# Provides access to virtual machine data managed by ONE and libvirt
class VirtualMachineCloudSI
      
      # Get virtual machine info
      def VirtualMachineCloudSI.get(vm_id)      
          vm = VirtualMachineOneSI.get(vm_id)
		  if ( !vm.deploy_id.nil? && vm.deploy_id != '' && !vm.host_name.nil? && vm.host_name != '' )
		     libvirt_vm = VirtualMachineLibvirtSI.get( vm.host_name, vm.deploy_id )
			 # merge vnc port
			 vm.graphics.port = libvirt_vm.graphics.port
			 
			 # merge tap devices
			 vm.nics.each do |nic|
			 	libvirt_vm.nics.each do |libvirt_nic|
				   if ( nic.mac == libvirt_nic.mac )
				      nic.dev = libvirt_nic.dev
					  break
				   end
			    end
			 end
		  end
          vm
      end
end  
