#!/usr/bin/env ruby

require 'mapping'
require 'virtual_machine_si'

# Provides access to virtual machine data managed by libvirt
class VirtualMachineLibvirtSI
      @@xml_mapping = 'libvirt_si_mapping'
      
      # Get virtual machine info
      def VirtualMachineLibvirtSI.get(host, deployId, xml_mapping=@@xml_mapping)      
          info = `ssh #{host} 'virsh -c qemu:///system dumpxml #{deployId}'`
          vm = VirtualMachineSI.from_xml(info, xml_mapping)
          vm.host_name = host unless vm.nil?
          vm
      end
end  
