#!/usr/bin/env ruby

require 'virtual_machine_si'

# Contains libvirt-specific XML mappings, that is used when marshalling libvirt XML messages

# VirtualMachine mapping
class VirtualMachineSI         
     include HappyMapper
     tag "domain"
     element :deploy_id, String, :tag => "name"     
     element :cpu,       Float,  :tag => "vcpu"     
     element :memory,    Float,  :tag => "memory"       
     has_many :disks,    DiskSI, :tag => "devices/disk", :deep => false     
     has_many :nics,     NicSI,  :tag => "devices/interface",  :deep => false
     element :graphics,  GraphicsSI, :tag => "devices/graphics",  :single => true,  :deep => false     
end

# VirtualMachine's Disk mapping
class DiskSI
      include HappyMapper
      tag "devices/disk"
      attribute :source, String, :tag => "source@file"
      attribute :dev,    String, :tag => "target@dev"
end

# VirtualMachine's NIC mapping
class NicSI              
      include HappyMapper
      tag "devices/interface"
      attribute :mac,     String, :tag => "mac@address"
      attribute :dev,     String, :tag => "target@dev"
end


# VirtualMachine's Graphics mapping
class GraphicsSI              
      include HappyMapper
      tag "devices/graphics"
      attribute :type,     String, :tag => "type"
      attribute :ip,       String, :tag => "listen"
      attribute :port,     String, :tag => "port"
      attribute :password, String, :tag => "password"
      attribute :keymap,   String, :tag => "keymap"
end
