#!/usr/bin/env ruby

require 'virtual_machine_si'

# Contains ONE-specific XML mappings, that is used when marshalling ONE XML messages

# VirtualMachine mapping
class VirtualMachineSI         
     include HappyMapper
     tag "VM"
     element :vm_id,     String, :tag => "ID"
     element :name,      String, :tag => "NAME"
     element :deploy_id, String, :tag => "DEPLOY_ID"     
     element :cpu,       Float,  :tag => "TEMPLATE/VCPU"     
     element :memory,    Float,  :tag => "TEMPLATE/MEMORY"     
     element :host_id,   String, :tag => "HISTORY/HID"     
     element :host_name, String, :tag => "HISTORY/HOSTNAME"     
     has_many :disks,    DiskSI, :tag => "TEMPLATE/DISK", :deep => false     
     has_many :nics,     NicSI,  :tag => "TEMPLATE/NIC",  :deep => false
     element :graphics,  GraphicsSI, :tag => "TEMPLATE/GRAPHICS",  :single => true,  :deep => false     
end

# VirtualMachine's Disk mapping
class DiskSI
      include HappyMapper
      tag "TEMPLATE/DISK"
      element :clone,  String, :tag => "CLONE"
      element :source, String, :tag => "SOURCE"
      element :size,   Float,  :tag => "SIZE"
      element :dev,    String, :tag => "TARGET"
      element :type,   String, :tag => "TYPE"
      element :format, String, :tag => "FORMAT"
      element :save,   String, :tag => "SAVE"
end

# VirtualMachine's NIC mapping
class NicSI              
      include HappyMapper
      tag "TEMPLATE/NIC"
      element :network, String, :tag => "NETWORK"
      element :ip,      String, :tag => "IP"
      element :mac,     String, :tag => "MAC"
      element :bridge,  String, :tag => "BRIDGE"
      element :dev,     String, :tag => "TARGET"
end


# VirtualMachine's Graphics mapping
class GraphicsSI              
      include HappyMapper
      tag "TEMPLATE/GRAPHICS"
      element :type,     String, :tag => "TYPE"
      element :ip,       String, :tag => "LISTEN"
      element :port,     String, :tag => "PORT"
      element :password, String, :tag => "PASSWORD"
      element :keymap,   String, :tag => "KEYMAP"
end